<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>PDF Page</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/html2pdf.js/0.9.2/html2pdf.bundle.min.js"></script>
    <style>
        .rotate {
            transform: rotate(180deg);
        }
    </style>
</head>
<body>
    <div id="step3" class="grid grid-cols-1 lg:grid-cols-12 gap-8 mt-8 mb-8">
        <div class="lg:col-span-12">
            <h2 class="text-2xl font-bold mb-4 text-center text-violet-700">Evaluation Results</h2>
        </div>
        <div id="evaluation-results" class="lg:col-span-12 mt-6 p-4 rounded-lg">
            {% for category, details in evaluation_results.items() %}
                <div class="border rounded-md p-4 mb-4">
                    <div class="flex justify-between items-center bg-gray-100 p-4 rounded-md">
                        {% if details.score >= 80 %}
                            <div class="flex items-center text-green-700">
                                <svg class="w-6 h-6 mr-2" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M5 13l4 4L19 7" />
                                </svg>
                                <h2 class="text-xl font-bold">{{ category }} - Passed</h2>
                            </div>
                        {% else %}
                            <div class="flex items-center text-red-700">
                                <svg class="w-6 h-6 mr-2" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                                </svg>
                                <h2 class="text-xl font-bold"> {{ category }} - Failed</h2>
                            </div>
                        {% endif %}
                    </div>
                    <div class="relative w-48 mr-6">
                        <div class="relative w-full h-4 bg-gray-200 rounded-md overflow-hidden ml-4 mr-6">
                            <div class="absolute top-0 left-0 h-full bg-green-500" style="width: {{ details.score }}%"></div>
                            <div class="absolute top-0 h-full bg-red-500" style="width: {{ 100 - details.score }}%; left: {{ details.score }}%"></div>
                        </div>
                        <div class="relative w-full mt-1 text-xs font-semibold" style="left: {{ details.score - 6 }}%">
                            {{ details.score }}%
                        </div>
                    </div>
                    {% for key, value in details.items() if key != 'score' %}
                        <div class="mt-4">
                            <div class="flex justify-between items-center bg-gray-200 p-4 cursor-pointer" onclick="toggleDetailBody(this)">
                                <h3 class="text-lg font-semibold">{{ key }}</h3>
                                <div class="flex items-center">
                                    <span class="text-sm text-gray-700 mr-2">Score: {{ value.score  }}%</span>
                                    <svg class="arrow-icon w-5 h-5" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M19 9l-7 7-7-7" />
                                    </svg>
                                </div>
                            </div>
                            <div class="mt-2 p-4 border-t border-gray-300 bg-gray-50 grid grid-cols-2 gap-4">
                                <div class="pr-2" id="evaluation_results_output">
                                    <p><strong>Type:</strong> {{ value.type }}</p>
                                    <p><strong>Evaluation Method:</strong> {{ value.method }}</p>
                                    <p><strong>Evaluation Criteria:</strong> {{ value.criteria }}</p>
                                    {% for i in range(value.question|length) %}
                                        {% if category == "TRANSPARENCY" %}
                                            <div class="bg-gray-100 rounded-md p-4 mt-2">
                                                <p><strong>Reasoning:</strong> {{  value.answer }}</p>
                                                <p><strong>Score:</strong> {{ value.score_list_single_question[i] }}</p>
                                            </div>
                                        {% elif category == "ROBUSTNESS" %}
                                            <div class="bg-gray-100 rounded-md p-4 mt-2">
                                                <p><strong>Answer:</strong> {{  value.answer[i] }}</p>
                                                <p><strong>Score:</strong> {{ value.score_list_single_question[0] }}</p>
                                            </div>
                                        {% else %}
                                            <div class="bg-gray-100 rounded-md p-4 mt-2">
                                                <p><strong>Answer:</strong> {{  value.answer[i] }}</p>
                                                <p><strong>Score:</strong> {{ value.score_list_single_question[i] }}</p>
                                            </div>
                                        {% endif %}
                                    {% endfor %}
                                </div>
                                <div class="pl-2" id="mitigation_output">
                                    <div>
                                        <h3 class="text-lg font-semibold">How to improve the score / Mitigation</h3>
                                        <p>{{ value.mitigation }}</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                </div>
            {% endfor %}
        </div>
        <div class="lg:col-span-12">
            <div class="left-btn">
                <button onclick="downloadPDF()" class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-3 px-6 rounded-md transition duration-300 ease-in-out mt-4">Download as PDF</button>
            </div>
        </div>
    </div>
    <script>
        function downloadPDF() {
            var element = document.getElementById('step3');
            var opt = {
                margin: 0.5,
                filename: 'Evaluation_Results.pdf',
                image: { type: 'jpeg', quality: 0.98 },
                html2canvas: { scale: 2 },
                jsPDF: { unit: 'in', format: 'letter', orientation: 'portrait' }
            };

            // New Promise-based usage:
            html2pdf().set(opt).from(element).save();
        }
    </script>
</body>
</html>
